var coffee, exec, fs, jsmin, lingo, nfile, sys, wrench;
var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
coffee = require('coffee-script');
sys = require('sys');
exec = require('child_process').exec;
fs = require('fs');
nfile = require('file');
wrench = require("wrench");
jsmin = require('jsmin').jsmin;
lingo = require('lingo');
this.CoffeeGrinder = {
  version: '0.0.0',
  app_name: 'unknown',
  header: ''
};
exports.CoffeeGrinder = this.CoffeeGrinder;
task("describe", __bind(function() {
  return console.log(this.CoffeeGrinder);
}, this));
task("test", __bind(function(options) {
  invoke('build');
  return exec("bundle exec jasmine-headless-webkit", function(error, stdout, stderr) {
    return console.log(stdout);
  });
}, this));
task('clean', __bind(function(options) {
  try {
    return wrench.rmdirSyncRecursive('builds');
  } catch (error) {

  }
}, this));
task('build', __bind(function(options) {
  var bigFile, compiled, dir, _i, _len, _ref;
  invoke('clean');
  fs.mkdirSync('builds', '0777');
  bigFile = this.CoffeeGrinder.header;
  _ref = ['app', 'lib'];
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    dir = _ref[_i];
    nfile.walkSync(dir, function(start, dirs, names) {
      var name, path, _j, _len2, _results;
      _results = [];
      for (_j = 0, _len2 = names.length; _j < _len2; _j++) {
        name = names[_j];
        path = [start, name].join('/');
        _results.push((function() {
          try {
            bigFile += fs.readFileSync(path, 'utf-8');
            return bigFile += "\n\n";
          } catch (error) {

          }
        })());
      }
      return _results;
    });
  }
  compiled = coffee.compile(bigFile);
  fs.writeFileSync("builds/" + this.CoffeeGrinder.app_name + ".edge.js", compiled);
  fs.writeFileSync("public/js/" + this.CoffeeGrinder.app_name + ".js", compiled);
  return console.log('Finished building');
}, this));
task('release', __bind(function(options) {
  invoke('build');
  fs.writeFileSync("builds/" + this.CoffeeGrinder.app_name + "-" + this.CoffeeGrinder.version + ".js", fs.readFileSync("builds/" + this.CoffeeGrinder.app_name + ".edge.js", 'utf-8'));
  return fs.writeFileSync("builds/" + this.CoffeeGrinder.app_name + "-" + this.CoffeeGrinder.version + ".min.js", jsmin(fs.readFileSync("builds/" + this.CoffeeGrinder.app_name + ".edge.js", 'utf-8')));
}, this));
option('-n', '--name [NAME]', 'name of the model');
task('generate:model', __bind(function(options) {
  var model, model_name, name, spec;
  name = options.name.replace(/\_/, ' ');
  name = lingo.camelcase(name, true);
  model_name = "" + this.CoffeeGrinder.model_module + name;
  model = "class @" + model_name + " extends Backbone.Model";
  fs.writeFileSync("app/models/" + options.name + ".coffee", model);
  spec = "describe \"" + model_name + "\", ->\n\n  beforeEach ->\n    @" + options.name + " = new " + model_name + "()\n\n  it \"should do something\", ->\n    console.log \"pending...\"\n";
  return fs.writeFileSync("spec/javascripts/models/" + options.name + "_spec.coffee", spec);
}, this));